com.amazon.redshift.util

## Class Base64

- java.lang.Object
- - com.amazon.redshift.util.Base64

    public class Base64
    extends Object

This code is a stripped down version of Robert Harder's Public Domain Base64 implementation. GZIP support, InputStream and OutputStream stuff and some unneeded encode/decode methods have been removed.

-- Original comments follow --

Encodes and decodes to and from Base64 notation.

Change Log:

- v2.1 - Cleaned up javadoc comments and unused variables and methods. Added some convenience methods for reading and writing to and from files.
- v2.0.2 - Now specifies UTF-8 encoding in places where the code fails on systems with other encodings (like EBCDIC).
- v2.0.1 - Fixed an error when decoding a single byte, that is, when the encoded data was a single byte.
- v2.0 - I got rid of methods that used booleans to set options. Now everything is more consolidated and cleaner. The code now detects when data that's being decoded is gzip-compressed and will decompress it automatically. Generally things are cleaner. You'll probably have to change some method calls that you were making to support the new options format (`int`s that you "OR" together).
- v1.5.1 - Fixed bug when decompressing and decoding to a byte[] using `decode( String s, boolean gzipCompressed )`. Added the ability to "suspend" encoding in the Output Stream so you can turn on and off the encoding if you need to embed base64 data in an otherwise "normal" stream (like an XML file).
- v1.5 - Output stream pases on flush() command but doesn't do anything itself. This helps when using GZIP streams. Added the ability to GZip-compress objects before encoding them.
- v1.4 - Added helper methods to read/write files.
- v1.3.6 - Fixed OutputStream.flush() so that 'position' is reset.
- v1.3.5 - Added flag to turn on and off line breaks. Fixed bug in input stream where last buffer being read, if not completely full, was not returned.
- v1.3.4 - Fixed when "improperly padded stream" error was thrown at the wrong time.
- v1.3.3 - Fixed I/O streams which were totally messed up.

I am placing this code in the Public Domain. Do with it as you will. This software comes with no guarantees or warranties but with plenty of well-wishing instead! Please visit http://iharder.net/base64 periodically to check for updates or to contribute improvements.

Version:
  2.1
Author:
  Robert Harder, rob@iharder.net

### Field Summary

Fields
`static int` `DECODE` Specify decoding.
`static int` `DONT_BREAK_LINES` Don't break lines when encoding (violates strict Base64 specification).
`static int` `ENCODE` Specify encoding.
`static int` `NO_OPTIONS` No options specified.

### Method Summary

All Methods Static Methods Concrete Methods
`static byte[]` `decode(byte[] source, int off, int len)` Very low-level access to decoding ASCII characters in the form of a byte array.
`static byte[]` `decode(String s)` Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.
`static String` `encodeBytes(byte[] source)` Encodes a byte array into Base64 notation.
`static String` `encodeBytes(byte[] source, int options)` Encodes a byte array into Base64 notation.
`static String` `encodeBytes(byte[] source, int off, int len)` Encodes a byte array into Base64 notation.
`static String` `encodeBytes(byte[] source, int off, int len, int options)` Encodes a byte array into Base64 notation.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### NO_OPTIONS

    public static final int NO_OPTIONS

No options specified. Value is zero.

See Also:
  Constant Field Values

#### ENCODE

    public static final int ENCODE

Specify encoding.

See Also:
  Constant Field Values

#### DECODE

    public static final int DECODE

Specify decoding.

See Also:
  Constant Field Values

#### DONT_BREAK_LINES

    public static final int DONT_BREAK_LINES

Don't break lines when encoding (violates strict Base64 specification).

See Also:
  Constant Field Values

### Method Detail

#### encodeBytes

    public static String encodeBytes(byte[] source)

Encodes a byte array into Base64 notation. Does not GZip-compress data.

Parameters:
  `source` - The data to convert
Returns:
  Base64 notation of input data
Since:
  1.4

#### encodeBytes

    public static String encodeBytes(byte[] source,
                                     int options)

Encodes a byte array into Base64 notation.

Valid options:

       GZIP: gzip-compresses object before encoding it.
       DONT_BREAK_LINES: don't break lines at 76 characters
         Note: Technically, this makes your encoding non-compliant.

Example: `encodeBytes( myData, Base64.GZIP )` or

Example: `encodeBytes( myData, Base64.GZIP | Base64.DONT_BREAK_LINES )`

Parameters:
  `source` - The data to convert
  `options` - Specified options
Returns:
  Base64 notation
Since:
  2.0
See Also:
  `DONT_BREAK_LINES`

#### encodeBytes

    public static String encodeBytes(byte[] source,
                                     int off,
                                     int len)

Encodes a byte array into Base64 notation. Does not GZip-compress data.

Parameters:
  `source` - The data to convert
  `off` - Offset in array where conversion should begin
  `len` - Length of data to convert
Returns:
  Base64 notation
Since:
  1.4

#### encodeBytes

    public static String encodeBytes(byte[] source,
                                     int off,
                                     int len,
                                     int options)

Encodes a byte array into Base64 notation.

Valid options:

       GZIP: gzip-compresses object before encoding it.
       DONT_BREAK_LINES: don't break lines at 76 characters
         Note: Technically, this makes your encoding non-compliant.

Example: `encodeBytes( myData, Base64.GZIP )` or

Example: `encodeBytes( myData, Base64.GZIP | Base64.DONT_BREAK_LINES )`

Parameters:
  `source` - The data to convert
  `off` - Offset in array where conversion should begin
  `len` - Length of data to convert
  `options` - Specified options
Returns:
  Base64 notation
Since:
  2.0
See Also:
  `DONT_BREAK_LINES`

#### decode

    public static byte[] decode(byte[] source,
                                int off,
                                int len)

Very low-level access to decoding ASCII characters in the form of a byte array. Does not support automatically gunzipping or any other "fancy" features.

Parameters:
  `source` - The Base64 encoded data
  `off` - The offset of where to begin decoding
  `len` - The length of characters to decode
Returns:
  decoded data
Since:
  1.3

#### decode

    public static byte[] decode(String s)

Decodes data from Base64 notation, automatically detecting gzip-compressed data and decompressing it.

Parameters:
  `s` - the string to decode
Returns:
  the decoded data
Since:
  1.4